/* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/CodGenC1_smokedrv.c,v
   Comment: Small driver used for testing efficiency
   Release: scope-0-16_final 

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTE:

   This is extremely similar to tiny driver, but also allows parameter 
   for number of iterations. Time is not measured (use system "time" or sthg 
   similar).

   CodGenC1_smokedrv.c,v 1.9 2003/07/23 21:20:46 wasowski Exp
*/

#include <stdlib.h>
#include <stdio.h>
#include <time.h>


int init (int argc) 
{
	if ( argc > 3 ) { 
		printf ("init,"); 
		fflush(stdout);
	}
	st_init(); 

}

int main (int argc,const  char * argv[])
{
	int i = 0;
	int j = 0;
	unsigned max1 = atoi (argv[1]);
	unsigned max2 = atoi (argv[2]) +1;

	printf ("Smoke test. Events %d. Limit %d. Number of tries %d...\n", EVENTNO, max2, max1);

	srand(time(NULL));
	init( argc );

	/* deliberate code repetition. This way the test is only performed
	 * once and does not influence the speed characteristic significantly
	 **/
	if ( max2 != 0 ) 
		for(; i<max1; ++i) {
			
			if (rand() % 100 == 0) 
				init( argc );
			
			j = rand();

			CurrEvent.tag = j % max2;
			if ( argc > 3 ) {
				printf ("%d,", CurrEvent.tag);
				fflush(stdout);
			}
			macrostep();
		}
	else for(; i < max1; ++i) {
			init( argc );
			if ( argc > 3 ) {
				printf ("%d,", CurrEvent.tag);
				fflush(stdout);
			}
			macrostep();
		}
	

	printf ("done\n");

	return 0;
}
