(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/HsmPrint.sml,v
   Comment: Saving HSM abstract syntax to text file.
   Release: scope-0-16_final 

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   HsmPrint.sml,v 1.6 2003/07/29 18:17:35 wasowski Exp
*)

structure HsmPrint : HSMPRINT = struct

open Hsm CodGen Typeset
infix 3 --;

fun path snames = String.concat (join_dots snames [])

fun cgtran i ({event,action,source,target} :tran) :codgen = 
	let val _ = fn () => map (fn s => print (s^" ")) target
	    val _ = fn () => print "\n"
	    val act = case action of [] => eoc
				   | a => sg " / " -- cg (join_blanks action [])
	in eol -- cg [i, event] -- act
		-- cg [" : ", path source, " -> ", path target, "\n"]
	end

fun cgOR i (OR (sid,kids,trans)) :codgen = 
	let 
	    val i1     = indin i
	    val prefix = cg ["\n", i, "@orstate ", sid, "{ "]
	    val kids   = foldl (fn (andst,cg)=> cg -- cgAND i1 andst) prefix kids
	    val trans  = foldl (fn (tr,cg)=> cg -- cgtran i1 tr) kids trans
	in trans -- sg "}" end

and cgAND i (AND (sid,ini,kids)) :codgen = 
	let 
	    val i1     = indin i  
	    val prefix = if ini then "@initial " else "@andstate "
	    val prefix = cg ["\n",i, prefix, sid, "{ " ] 
	    val kids   = foldl (fn (orst,cg)=> cg -- cgOR i1 orst) prefix kids
	in kids -- sg "}" end

fun print { events, actions, hierarchy } :codgen = 
	let val actions = if null actions then eoc 
			  else cg (join_blanks ("@action"::actions) [])
	    val events  = if null events then eoc
			  else cg (join_blanks ("@event"::events)   []) 
	in events -- eol -- actions -- eol -- cgAND "" hierarchy end
		
end
