(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/RL.sig,v
   Comment: Signature for RL module
   Release: scope-0-16_final 

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   RL.sig,v 1.3 2003/05/05 14:04:58 wasowski Exp
*)

signature RL = sig

datatype property = NeverE of string
		  | ConstrV of Types.simplety * string * Types.value
		  | ConstrF of Types.simplety * string * Types.value
		  | Dead of Types.simplety * string
		  | Pure of Types.simplety * string
type restriction = string * string list * property list 

datatype block = Inter of restriction
	       | IBinding of string * string

type rl_ast = block list

(* refined representation forwarded to specializer *)
(* all references fully expanded                   *)

eqtype event 

type fuprop = Types.simplety * Types.value option * bool
type vaprop = Types.simplety * Types.value option * bool

type restr = { vaprop :vaprop SymbolEnv.env,
               fuprop :fuprop SymbolEnv.env,
	       nevere :Set.set }


type rl = { restr :restr SymbolEnv.env,
            sys   :restr SymbolEnv.env }

val empty :rl

val flatten : rl_ast * rl -> rl

end
