(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/parserl-sig.sml,v
   Comment: Signature of Parser for RL(restriction language)
   Release: scope-0-16_final

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*)

signature PARSERL = sig

	include RL

	datatype token  = T_RESTRICTION | T_LBR | T_RBR | T_RESTRICTS | T_CONST 
		| T_EQUALS | T_IMPOSSIBLE | T_OCCURS | T_PURE | T_DEAD 
		| T_COMMA | T_COLON | T_PARENTHESIZED 
		| T_SEMICOLON
		| T_CSTI of int  
		| T_CSTR of real 
		| T_NAME of string

	type ('elm,'res) parser

	val tokenizer : (char, token list) parser
	val parser    : (token, rl_ast) parser

	val scanFile  : string -> token list option
	val parseFile : string -> rl_ast option
end
