# Hi emacs! This is -*- makefile -*-
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/makefile.inc,v
# Comment: makefile for launching tests of SCOPE
#          Does not work independently. Use main SCOPE makefile instead. 
# Release: scope-0-16_final
#
#    Copyright (C) 2001-2004 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# makefile.inc,v 1.42 2004/05/13 20:24:38 wasowski Exp

# models to be linked from externum

LINKMODELS := test/run/cdplayer.vsp  test/run/cdplayer.vsr \
	      test/run/cdplayer1.vsp test/run/cdplayer1.vsr \
	      test/run/cdplayer2.vsp test/run/cdplayer2.vsr \
	      test/run/cdplayer3.vsp test/run/cdplayer3.vsr \
	      test/run/history01.vsp test/run/history01.system.topstate.vsr \
	      test/run/history03.vsp test/run/history03.system.topstate.vsr \
	      test/run/history04.vsp test/run/history04.system.topstate.vsr \
	      test/run/neg01.vsp     test/run/neg01.system.topstate.vsr \
	      test/run/neg02.vsp     test/run/neg02.system.topstate.vsr \
	      test/run/neg03.vsp     test/run/neg03.system.topstate.vsr \
	      test/run/signals01.vsp test/run/signals01.system.topstate.vsr \
	      test/run/signals02.vsp test/run/signals02.system.topstate.vsr \
	      test/run/signals03.vsp test/run/signals03.system.topstate.vsr \
	      test/run/spec01.vsp    test/run/spec01.system.topstate.vsr \
	      test/run/spec02.vsp    test/run/spec02.system.topstate.vsr \
	      test/run/spec03.vsp    test/run/spec03.system.topstate.vsr \
	      test/run/trans11.vsp   test/run/trans11.system.topstate.vsr \
	      test/run/trans12.vsp   test/run/trans12.system.topstate.vsr \
	      test/run/trans13.vsp   test/run/trans13.system.topstate.vsr \
	      test/run/trans14.vsp   test/run/trans14.system.topstate.vsr \
	      test/run/trans15.vsp   test/run/trans15.system.topstate.vsr \
	      test/run/trios01.vsp   test/run/trios01.system.topstate.vsr \
              test/run/trios02.vsp   test/run/trios02.system.topstate.vsr \
              test/run/trios03.vsp   test/run/trios03.system.topstate.vsr 


test/run/%.vsp : 
	@(test -s ${GENERICDIR}/$*/$*.vsp && \
		ln -sf ${GENERICDIR}/$*/$*.vsp $@) \
	|| (test -s ${COMPILABLEDIR}/$*/$*.vsp && \
		ln -sf ${COMPILABLEDIR}/$*/$*.vsp $@)

test/run/%.system.topstate.vsr :
	@(test -s ${GENERICDIR}/$*/$*.system.topstate.vsr && \
		ln -sf ${GENERICDIR}/$*/$*.system.topstate.vsr $@) \
	|| (test -s ${COMPILABLEDIR}/$*/$*.system.topstate.vsr && \
		ln -sf ${COMPILABLEDIR}/$*/$*.system.topstate.vsr $@)

test/run/%.vsr :
	@(test -s ${GENERICDIR}/$*/$*.vsr && \
		ln -sf ${GENERICDIR}/$*/$*.vsr $@) \
	|| (test -s ${COMPILABLEDIR}/$*/$*.vsr && \
		ln -sf ${COMPILABLEDIR}/$*/$*.vsr $@)

# at this level we introduce more phony targets

.PHONY: test stats fullstats test_VsrAbsyn test_Interpr test_CodGenC1 \
	test_CodGenC1i test_CodGenC1s test_CodGenR test_StaticScope \
	test_CommandLine test_parser test_Specialize test_Optimize debug \
	test_HsmConversions test_WuddySys linkmodels all




# add test modules to general compilation

all: muddy test/src/Test.uo,smartmade				\
     test/src/tInterprLang.uo,smartmade				\
     MainTest.uo,smartmade tCodGenC1c,smartmade			\
     tCodGenCFc,smartmade test/src/testset-sig.ui,smartmade	\
     test/src/test-fn.uo,smartmade				\
     test/src/tRLCommon.uo,smartmade linkmodels scope

# open debugging session

debug: 	all 
	${MOSMLI} test/src/use.sml


test: 	all test_StaticScope test_CommandLine test_CodGenR	\
	test_CodGen test_Interpr test_VsrAbsyn test_HsmConversions	\
	test_parserl test_Specialize test_WuddySys

test_CodGen  : test_CodGenC1 test_CodGenCF
test_CodGenC1: test_CodGenC1i test_CodGenC1c test_CodGenC1s
test_CodGenCF: test_CodGenCFi test_CodGenCFc test_CodGenCFs

# all three interpreters (just a shortcut for manual calls)

test_CodGenCi: test_Interpr test_CodGenCFi test_CodGenC1i 
test_CodGenCc: test_CodGenCFc test_CodGenC1c
test_CodGenCs: test_CodGenCFs test_CodGenC1s

# get statistics (script works in scope/test directory)

stats : all
	@test/src/getstat.pl -s | grep -v "! Warning" | grep -v "error" 

fullstats: all
	@test/src/getstat.pl -S | grep -v "! Warning" | grep -v "error" 

# this test does not work (it never really worked so not a big loss)

test_parser: all
	@echo "Check the results in file: test_parser_results"
	@cd test/parser && ./run 
	@mv test/parser/test_results .

test_VsrAbsyn: all 
	@cat test/src/tVsrAbsyn.sml | $(MOSML)


test_Interpr: all
	@cat test/src/tInterpr.sml  | $(MOSML)

test_CodGenC1c: all $(LINKMODELS)
	@./tCodGenC1c --confset
	@./tCodGenC1c

test_CodGenCFc: all $(LINKMODELS)
	@./tCodGenCFc

test_CodGenC1i: all
	@(echo "val preopts=\"\"; val codgen=\"C1\";" && \
		cat test/src/tCodGenCi.sml) | $(MOSML)
	@(echo "val preopts=\"--confset\"; val codgen=\"C1\";" && \
		cat test/src/tCodGenCi.sml) | $(MOSML)

test_CodGenCFi: all
	@(echo "val preopts=\"\"; val codgen=\"CF\";" && \
		cat test/src/tCodGenCi.sml) | $(MOSML)


test_CodGenC1s: all $(LINKMODELS)
	@test/src/tCodGenCs.pl C1
	@test/src/tCodGenCs.pl C1 --confset

test_CodGenCFs: all $(LINKMODELS)
	@test/src/tCodGenCs.pl CF

test_StaticScope: all
	@cat test/src/tStaticScope.sml | $(MOSML)
#	$(MOSML) test/src/tStaticScope.sml 

test_WuddySys: all
	@cat test/src/tWuddySys.sml | $(MOSML)

test_CommandLine: all 
	@test/src/tCommandLine.pl

test_CodGenR: all $(LINKMODELS)
	@test/src/tCodGenR.pl

test_HsmConversions: all $(LINKMODELS)
	@test/src/tHsmConversions.pl

test_parserl: all
	@cat test/src/tparserl-lexer.sml | $(MOSML) test/src/init.sml && \
	 cat test/src/tparserl-parser.sml | $(MOSML) && \
	 cat test/src/tparserl-file.sml | $(MOSML) && \
	 cat test/src/tRL.sml | $(MOSML) test/src/init.sml

test_Specialize: all $(LINKMODELS)
	@cat test/src/tSpecialize.sml | $(MOSML) test/src/init.sml

test_Optimize: all $(LINKMODELS)
	@cat test/src/tOptimize.sml | $(MOSML) test/src/init.sml

# local extension to clean

clean: test_clean

# local (a hack not to overwrite existing cleaning)
test_clean:
	rm -f test/parser/sandbox1/*.* test/parser/sandbox2/*.*  
	rm -f test_parser_results
	rm -f $(LINKMODELS)

mrprop: clean test_mrprop

# local (a hack not to overwrite existing mrprop commands)
test_mrprop:
	rm -Rf test/sandbox/ test/sandbox1/ test/sandbox2/

#just a hook

linkmodels: $(LINKMODELS)
