#!/usr/bin/perl -w 
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tCodGenR.pl,v
# Comment: Regression tests called one after another
# Release: scope-0-16_final
#
#    Copyright (C) 2001-2002 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# As all the scripts in this directory it is supposed to be run from
# scope/test not from scope/test/src. 
# 
# tCodGenR.pl,v 1.10 2003/07/27 09:18:59 wasowski Exp

use File::stat;
use test::src::ScopeTest;

sub peer_based_reg () {
	
	return ((system "rm -Rf test/sandbox")==0 && (system "mkdir test/sandbox") == 0 &&
		   (system "test/src/compile.pl test/run/peer.vsp C1 test/sandbox/ --confset") == 0) &&
	   		# this was caused by lack of sorting in 
			# generation of state dictionary in *Indirect* mode
			# (scheduling module)
		   (system "echo init macro E_Clock_Invalid quit | test/sandbox/system") == 0 &&
		   	# probably caused by the same bug above
		   (system "echo init macro E_Door_Close quit | test/sandbox/system") == 0;
}

# unmangling was wrongly done which was detected by following testcase
# (trios01)
sub unmangle_pcnc_encoded () {

	return ((system "rm -Rf test/sandbox") == 0 &&
		(system "test/src/compile.pl test/run/trios01.vsp C1 test/sandbox/ --confset") == 0 &&
 		(system "echo init macro E_below_top quit | test/sandbox/system > /dev/null") == 0 );
}
	 	
 		

ScopeTest::test_init( "CodGenC1 regression tests" );
$success = 1;

$success = (system "test/src/tDoubleInit.pl") == 0;
$success = ScopeTest::dotest(\&peer_based_reg, "peer.vsp regressions") && $success;
$success = ScopeTest::dotest(\&unmangle_pcnc_encoded, "unmangling in encoded mode[trios01.vsp]") && $success;

ScopeTest::test_finalize( $success );

