(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tOptimize.sml,v
   Comment: testcases for Optimize.sml
   Release: scope-0-16_final

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   tOptimize.sml,v 1.1 2004/05/05 21:48:43 wasowski Exp
*)

app load ["Main","tRLCommon","Specialize"];

structure tSpecialize : TEST_SET = struct

val name = "Specialize";

(* testcases *)
type aor = unit
type atr = unit

type input  = unit 
type output = (aor,atr) Absyn.model * (aor,atr) Absyn.model option	
		(* full_model, optimized *)
type testcase = string * input * (output -> bool)

(* helpers *)

fun isExpr (Expr _) = true
  | isExpr (Assgn _)= false

fun CASE file accept = (file, (), fn (p,n)=> accept(p,valOf n))

val testcases : testcase list = [ 

		CASE "test/run/climate.vsp" (all2 op<>) (* FIXME *)
	
	]; (* end of testcases *)


	fun run (name,()) =
		let val m = #1 (valOf (Main.parse_VS name))
		in 
			(m,SOME (Optimize.apply () name m)) 
			handle (Err.ScopeExn _) => (m,NONE)
		end 
		

end


structure TF = TestFn(tSpecialize);

TF.go();
