(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/util/Say.sig,v
   Comment: Controlled verbosity output (AW 2002)
   Release: scope-0-16_final

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   Say.sig,v 1.4 2003/07/29 12:33:33 wasowski Exp
*)

signature Say = sig

	eqtype verbosity

	val VOverKill: verbosity
	val Verbose  : verbosity 
	val VHigh    : verbosity 
	val VMed     : verbosity 
	val VWarning : verbosity
	val VNorm    : verbosity 
	val VLow     : verbosity
	val VQuiet   : verbosity 

	val fromInt : int -> verbosity	
	val setverbosity : verbosity -> unit
	val getverbosity : unit -> verbosity
	val printverbosity: unit -> string

	val say   : verbosity -> string -> unit
	val sayln : verbosity -> string -> unit

	val println      : string      -> unit
	val printi       : int         -> unit
	val printintlist : int list    -> unit
	val printslist   : string list -> unit
	val printslistln : string list -> unit

	val cr : unit -> unit

	val IfVOverKill: (unit -> unit) -> unit
	val IfVerbose  : (unit -> unit) -> unit
	val IfVHigh    : (unit -> unit) -> unit
	val IfVWarning : (unit -> unit) -> unit

end

