(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/util/Symbol.sig,v
   Comment: Signature of Symbol structure for symbol tables
            Significantly influenced by A.Appels "Modern Compiler
	    Implementation"
   Release: scope-0-16_final

     Copyright (C) 2001-2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   Symbol.sig,v 1.2 2003/05/05 20:55:45 wasowski Exp
*)

signature Symbol =
sig
  eqtype symbol
  val symbol    : string -> symbol
  val compare   : symbol * symbol -> order

  val name	: symbol -> string
  val anonymize : bool   -> unit

  val fresh     : unit   -> symbol

  val toInt     : symbol -> int

  val nullsymbol :symbol
  
(*

  [compare (s1,s2)] Compares to symbols. Note that this is not a lexical
  comparison (though equality can be used like that). The purpose is to allow 
  ordered data structures to be built.

*)
end


